open Datatypes

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type 'a coq_sig = 'a
  (* singleton inductive, whose constructor was exist *)

(** val sig_rect : ('a1 -> __ -> 'a2) -> 'a1 coq_sig -> 'a2 **)

let sig_rect f s =
  f s __

(** val sig_rec : ('a1 -> __ -> 'a2) -> 'a1 coq_sig -> 'a2 **)

let sig_rec f s =
  f s __

type 'a sig2 = 'a
  (* singleton inductive, whose constructor was exist2 *)

(** val sig2_rect : ('a1 -> __ -> __ -> 'a2) -> 'a1 sig2 -> 'a2 **)

let sig2_rect f s =
  f s __ __

(** val sig2_rec : ('a1 -> __ -> __ -> 'a2) -> 'a1 sig2 -> 'a2 **)

let sig2_rec f s =
  f s __ __

type ('a, 'p) sigS =
  | Coq_existS of 'a * 'p

(** val sigS_rect : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) sigS -> 'a3 **)

let sigS_rect f = function
  | Coq_existS (x, x0) -> f x x0

(** val sigS_rec : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) sigS -> 'a3 **)

let sigS_rec f = function
  | Coq_existS (x, x0) -> f x x0

type ('a, 'p, 'q) sigS2 =
  | Coq_existS2 of 'a * 'p * 'q

(** val sigS2_rect : ('a1 -> 'a2 -> 'a3 -> 'a4) -> ('a1, 'a2, 'a3) sigS2 ->
                     'a4 **)

let sigS2_rect f = function
  | Coq_existS2 (x, x0, x1) -> f x x0 x1

(** val sigS2_rec : ('a1 -> 'a2 -> 'a3 -> 'a4) -> ('a1, 'a2, 'a3) sigS2 ->
                    'a4 **)

let sigS2_rec f = function
  | Coq_existS2 (x, x0, x1) -> f x x0 x1

(** val proj1_sig : 'a1 coq_sig -> 'a1 **)

let proj1_sig e =
  e

(** val projS1 : ('a1, 'a2) sigS -> 'a1 **)

let projS1 = function
  | Coq_existS (a, p) -> a

(** val projS2 : ('a1, 'a2) sigS -> 'a2 **)

let projS2 = function
  | Coq_existS (x0, h) -> h

(** val sumbool_rect : (__ -> 'a1) -> (__ -> 'a1) -> bool -> 'a1 **)

let sumbool_rect f f0 = function
  | true -> f __
  | false -> f0 __

(** val sumbool_rec : (__ -> 'a1) -> (__ -> 'a1) -> bool -> 'a1 **)

let sumbool_rec f f0 = function
  | true -> f __
  | false -> f0 __

(** val sumor_rect : ('a1 -> 'a2) -> (__ -> 'a2) -> 'a1 option -> 'a2 **)

let sumor_rect f f0 = function
  | Some x -> f x
  | None -> f0 __

(** val sumor_rec : ('a1 -> 'a2) -> (__ -> 'a2) -> 'a1 option -> 'a2 **)

let sumor_rec f f0 = function
  | Some x -> f x
  | None -> f0 __

(** val coq_Choice : ('a1 -> 'a2 coq_sig) -> ('a1 -> 'a2) coq_sig **)

let coq_Choice h z =
  h z

(** val coq_Choice2 : ('a1 -> ('a2, 'a3) sigS) -> ('a1 -> 'a2, 'a1 -> 'a3)
                      sigS **)

let coq_Choice2 h =
  Coq_existS ((fun z -> let Coq_existS (y, r) = h z in y), (fun z ->
    let Coq_existS (x, r) = h z in r))

(** val bool_choice : ('a1 -> bool) -> ('a1 -> bool) coq_sig **)

let bool_choice h z =
  match h z with
    | true -> true
    | false -> false

type 'a coq_Exc = 'a option

(** val value : 'a1 -> 'a1 option **)

let value x =
  Some x

(** val error : __ -> 'a1 option **)

let error _ =
  None

(** val except : __ -> 'a1 **)

let except _ =
  assert false (* absurd case *)

(** val absurd_set : __ -> 'a1 **)

let absurd_set _ =
  assert false (* absurd case *)

type ('a, 'p) sigT =
  | Coq_existT of 'a * 'p

(** val sigT_rect : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) sigT -> 'a3 **)

let sigT_rect f = function
  | Coq_existT (x, x0) -> f x x0

(** val sigT_rec : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) sigT -> 'a3 **)

let sigT_rec f = function
  | Coq_existT (x, x0) -> f x x0

(** val projT1 : ('a1, 'a2) sigT -> 'a1 **)

let projT1 = function
  | Coq_existT (x, p) -> x

(** val projT2 : ('a1, 'a2) sigT -> 'a2 **)

let projT2 = function
  | Coq_existT (x, h0) -> h0

